<?php

namespace Litecms\Slider\Http\Controllers;

use App\Http\Controllers\PublicWebController as PublicController;
use Litecms\Slider\Interfaces\SliderRepositoryInterface;

class SliderPublicWebController extends PublicController
{
    /**
     * Constructor.
     *
     * @param type \Litecms\Slider\Interfaces\SliderRepositoryInterface $slider
     *
     * @return type
     */
    public function __construct(SliderRepositoryInterface $slider)
    {
        $this->repository = $slider;
        parent::__construct();
    }

    /**
     * Show slider's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $sliders = $this->repository->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();

        return $this->theme->of('slider::public.slider.index', compact('sliders'))->render();
    }

    /**
     * Show slider.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $slider = $this->repository->scopeQuery(function($query) use ($slug) {
            return $query->orderBy('id','DESC')
                         ->where('slug', $slug);
        })->first(['*']);

        return $this->theme->of('slider::public.slider.show', compact('slider'))->render();
    }
}
